<?php if (!defined('PmWiki')) exit();
/* PmWiki Blix skin
 *
 * Examples at: http://pmwiki.com/Cookbook/Blix and http://solidgone.org/Skins/
 * Copyright (c)2016 David Gilbert
 * This work is licensed under a Creative Commons Attribution-Share Alike 4.0 International License.
 * Please retain the links in the footer.
 * http://creativecommons.org/licenses/by-sa/4.0/
 * 
 * Updated for PHP 7 by Petko Yotov www.pmwiki.org/petko
 */
global $FmtPV;
$FmtPV['$SkinName'] = '"Blix"';
$FmtPV['$SkinVersion'] = '"2020-03-03"';

global $Blix_Width, $Blix_TitleBg, $Blix_TitleColor, $SkinDirUrl, $HTMLStylesFmt;
SDV($HTMLStylesFmt['blix'], '');
if (!empty($Blix_TitleBg))
	$HTMLStylesFmt['blix'] .= '#header {background-image:url(' .$SkinDirUrl . '/images/backgrounds/' . $Blix_TitleBg .'); '
		.(!empty($Blix_TitleColor) ?' background-color:'.$Blix_TitleColor.';' :'') .'}';
if (!empty($Blix_Width))
	$HTMLStylesFmt['blix'] .= '#container, #credits {max-width:' .$Blix_Width .';}';

global $PageLogoUrl, $PageLogoUrlHeight, $PageLogoUrlWidth,$SkinColor;
if (!empty($PageLogoUrl)) {
	dg_SetLogoHeightWidth(15);

	$HTMLStylesFmt['blix'] .= '#header .sitetitle a{height:' .$PageLogoUrlHeight .'; background: url(' .$PageLogoUrl .') left top no-repeat} '.
		'#header .sitetitle a, #header .sitetag{padding-left: ' .$PageLogoUrlWidth .'} '.
		'#header .sitetag{margin-top: ' .(30-substr($PageLogoUrlHeight,0,-2)) .'px}';
}
$SkinColor = dg_SetSkinColor('spring', array('spring','autumn'));
global $HTMLHeaderFmt;
SDV($HTMLHeaderFmt['jquery.js'], '<script type="text/javascript" src="' .$SkinDirUrl .'/javascript/jquery.min.js"></script>');
SDV($HTMLHeaderFmt['blix.js'], '<script type="text/javascript" src="' .$SkinDirUrl .'/javascript/blix.js"></script>');

# ----------------------------------------
# - Standard Skin Setup
# ----------------------------------------
$FmtPV['$WikiTitle'] = '$GLOBALS["WikiTitle"]';
$FmtPV['$WikiTag'] = '$GLOBALS["WikiTag"]';

# Move any (:noleft:) or SetTmplDisplay('PageLeftFmt', 0); directives to variables for access in jScript.
$FmtPV['$LeftColumn'] = "\$GLOBALS['TmplDisplay']['PageLeftFmt']";
$FmtPV['$RightColumn'] = "\$GLOBALS['TmplDisplay']['PageRightFmt']";
$FmtPV['$ActionBar'] = "\$GLOBALS['TmplDisplay']['PageActionFmt']";
$FmtPV['$TabsBar'] = "\$GLOBALS['TmplDisplay']['PageTabsFmt']";
$FmtPV['$SearchBar'] = "\$GLOBALS['TmplDisplay']['PageSearchFmt']";
$FmtPV['$TitleGroup'] = "\$GLOBALS['TmplDisplay']['PageTitleGroupFmt']";
Markup('fieldset', 'inline', '/\\(:fieldset:\\)/i', "<fieldset>");
Markup('fieldsetend', 'inline', '/\\(:fieldsetend:\\)/i', "</fieldset>");

Markup('nosearch', 'directives',  '/\\(:nosearch:\\)/i', "mu_BlixTmplDisplay");
Markup('notitle', 'directives',  '/\\(:notitle:\\)/i', "mu_BlixTmplDisplay");
Markup('notitlegroup', 'directives',  '/\\(:notitlegroup:\\)/i', "mu_BlixTmplDisplay");
Markup('notabs', 'directives',  '/\\(:notabs:\\)/i', "mu_BlixTmplDisplay");
function mu_BlixTmplDisplay($m) {
  extract($GLOBALS["MarkupToHTML"]);
  switch ($markupid) {
    case 'nosearch': return SetTmplDisplay('PageSearchFmt',0);
    case 'notitle':  return SetTmplDisplay('PageTitleFmt',0) . SetTmplDisplay('PageTitleGroupFmt',0);
    case 'notitlegroup': return SetTmplDisplay('PageTitleGroupFmt',0);
    case 'notabs':   return SetTmplDisplay('PageTabsFmt',0);
  }
}

# Override pmwiki styles otherwise they will override styles declared in css
global $HTMLStylesFmt;
$HTMLStylesFmt['pmwiki'] = '';

# Add a custom page storage location
global $WikiLibDirs;
$PageStorePath = dirname(__FILE__)."/wikilib.d/{\$FullName}";
$where = count($WikiLibDirs);
if ($where>1) $where--;
array_splice($WikiLibDirs, $where, 0, array(new PageStore($PageStorePath)));

# ----------------------------------------
# - Standard Skin Functions
# ----------------------------------------
function dg_SetSkinColor($default, $valid_colors){
global $SkinColor, $ValidSkinColors, $_GET;
	if ( !is_array($ValidSkinColors) ) $ValidSkinColors = array();
	$ValidSkinColors = array_merge($ValidSkinColors, $valid_colors);
	if ( isset($_GET['color']) && in_array($_GET['color'], $ValidSkinColors) )
		$SkinColor = $_GET['color'];
	elseif ( !in_array($SkinColor, $ValidSkinColors) )
		$SkinColor = $default;
	return $SkinColor;
}
function dg_PoweredBy(){
	print ('<a href="https://www.pmwiki.org/'.($GLOBALS['bi_BlogIt_Enabled']?'wiki/Cookbook/BlogIt">BlogIt':'">PmWiki').'</a>');
}
# Determine logo height and width
function dg_SetLogoHeightWidth ($wPad, $hPad=0){
global $PageLogoUrl, $PageLogoUrlHeight, $PageLogoUrlWidth;
	if (!isset($PageLogoUrlWidth) || !isset($PageLogoUrlHeight)){
		$size = @getimagesize($PageLogoUrl);
		if (!isset($PageLogoUrlWidth))  SDV($PageLogoUrlWidth, ($size ?$size[0]+$wPad :0) .'px');
		if (!isset($PageLogoUrlHeight))  SDV($PageLogoUrlHeight, ($size ?$size[1]+$hPad :0) .'px');
	}
}
